using System;

namespace Delegates
{
	/// <summary>
	/// A person
	/// </summary>
	public class CPerson
	{
		#region MEMBERS
		private string m_strFirstName, m_strLastName;
		private DateTime m_dtDateOfBirth;
		#endregion

		#region CONSTRUCTORS
		public CPerson():this("", "")
		{}
		public CPerson(string strFirstName, string strLastName):this(strFirstName, strLastName, DateTime.Today)
		{}
		
		public CPerson(string strFirstName, string strLastName, DateTime dtDateOfBirth)
		{
			m_strFirstName = strFirstName;
			m_strLastName=strLastName;
			m_dtDateOfBirth=dtDateOfBirth;
		}
		#endregion
		
		#region PROPERTIES
		public string FirstName
		{
			get{return m_strFirstName;}
			set{m_strFirstName=value;}
		}
		public string LastName
		{
			get{return m_strLastName;}
			set{m_strLastName=value;}
		}
		public DateTime DateOfBirth
		{
			get{return m_dtDateOfBirth;}
			set{m_dtDateOfBirth=value;}
		}
		public int GetAge()
		{
			return ((DateTime.Now.Month+DateTime.Now.Day) < (m_dtDateOfBirth.Month+m_dtDateOfBirth.Day))?DateTime.Now.Year-m_dtDateOfBirth.Year-1:DateTime.Now.Year-m_dtDateOfBirth.Year;
		}
		#endregion
	}
}
